# Generic GNU Make driver file.

CONFIG= debug
GEN_SOURCE_DIR= Generated_Source/PSoC5

include ../platform_debugbert.mk
include app_source.mk
include $(GEN_SOURCE_DIR)/gen_source.mk

GEN_OBJECTS_CortexM3= $(addprefix $(OUT_DIR_CortexM3)/,$(notdir $(addsuffix .o,$(basename $(GEN_C_SOURCE_CortexM3))))) $(addprefix $(OUT_DIR_CortexM3)/,$(notdir $(addsuffix .o,$(basename $(GEN_ASM_SOURCE_CortexM3))))) 
GEN_SEP_OBJECTS_CortexM3= $(addprefix $(OUT_DIR_CortexM3)/,$(notdir $(addsuffix .o,$(basename $(GEN_SEP_C_SOURCE_CortexM3))))) 
DEPS_CortexM3= $(addprefix $(OUT_DIR_CortexM3)/,$(notdir $(addsuffix .c.d,$(basename $(APP_C_SOURCE_CortexM3))))) $(addprefix $(OUT_DIR_CortexM3)/,$(notdir $(addsuffix .c.d,$(basename $(GEN_C_SOURCE_CortexM3))))) $(addprefix $(OUT_DIR_CortexM3)/,$(notdir $(addsuffix .c.d,$(basename $(GEN_SEP_C_SOURCE_CortexM3))))) 
APP_OBJECTS_CortexM3= $(addprefix $(OUT_DIR_CortexM3)/,$(notdir $(addsuffix .o,$(basename $(APP_C_SOURCE_CortexM3))))) 


all : intro outtro

intro: 
	$(info Building ################### $(CURDIR) ###################)

outtro:	$(OUT_DIR_CortexM3)/$(DESIGN).hex
	$(info Building done ############## $(CURDIR) ###################)

Generated_Source\PSoC5\cybootloader.c : export\prebuild.bat Generated_Source\PSoC5\cybootloader.icf
	export\prebuild.bat

postbuild_CortexM3= export\postbuild.bat

$(OUT_DIR_CortexM3)/$(DESIGN).hex :  $(OUT_DIR_CortexM3) Generated_Source\PSoC5\cybootloader.c $(OUT_DIR_CortexM3)/$(DESIGN).elf
	$(info $(basename $(CURDIR)) elf to hex and cyacd)
	@$(postbuild_CortexM3) $(OUT_DIR_CortexM3)/$(DESIGN).elf $(OUT_DIR_CortexM3)

$(OUT_DIR_CortexM3)/$(DESIGN).elf : $(APP_OBJECTS_CortexM3) $(GEN_SEP_OBJECTS_CortexM3) $(OUT_DIR_CortexM3)/$(DESIGN).a $(GEN_LIBS_CortexM3) $(APP_LIBS_CortexM3)
	$(info $(basename $(CURDIR)) $<)
	@"$(LD)" -Wl,--start-group $^ -o $@ $(LDFLAGS_CortexM3) -Wl,--end-group

$(OUT_DIR_CortexM3)/$(DESIGN).a : $(GEN_OBJECTS_CortexM3)
	$(info $(basename $(CURDIR)) $<)
	@"$(AR)" $(ARFLAGS) $@ $^

$(OUT_DIR_CortexM3):
	@mkdir $(subst /,\,$(OUT_DIR_CortexM3))

$(OUT_DIR_CortexM3)/%.o : $(GEN_SOURCE_DIR)/%.c
	$(info $(basename $(CURDIR)) $<)
	@"$(CC)" $(CDEPGEN_CortexM3)
	@"$(CC)" -c $(CFLAGS_CortexM3) $< -o $@

$(OUT_DIR_CortexM3)/%.o : $(GEN_SOURCE_DIR)/%.s
	$(info $(basename $(CURDIR)) $<)
	@"$(AS)" $(ASFLAGS_CortexM3) $< -o $@

$(OUT_DIR_CortexM3)/%.o : %.c
	$(info $(basename $(CURDIR)) $<)
	@"$(CC)" $(CDEPGEN_CortexM3)
	@"$(CC)" -c $(CFLAGS_CortexM3) $< -o $@

$(OUT_DIR_CortexM3)/%.o : ../common/%.c
	$(info $(basename $(CURDIR)) $<)
	@"$(CC)" $(CDEPGEN_CortexM3)
	@"$(CC)" -c $(CFLAGS_CortexM3) $< -o $@

$(OUT_DIR_CortexM3)/%.o : ../main/%.c
	$(info $(basename $(CURDIR)) $<)
	@"$(CC)" $(CDEPGEN_CortexM3)
	@"$(CC)" -c $(CFLAGS_CortexM3) $< -o $@

.PHONY: all clean intro outtro build

clean:
	$(clean      ################### $(CURDIR) ###################)
	-$(RM) $(RMFLAGS) $(OUT_DIR_CortexM3)
	$(clean done ################### $(CURDIR) ###################)
build: all	

-include $(DEPS_CortexM3)
