# Macros required for the generic driver for toolchain and/or operating system.

DESIGN= PSOCBaseV1B
CONFIG= debug
TOOLCHAIN_DIR ?= C:/Program Files (x86)/Cypress/PSoC Creator/4.4/PSoC Creator/import/gnu/arm/5.4.1/bin

CC_BASE= arm-none-eabi-gcc
CC= $(TOOLCHAIN_DIR)/$(CC_BASE)

OUT_DIR_CortexM3= CortexM3\ARM_GCC_541\Debug
CFLAGS_CortexM3= -mcpu=cortex-m3 -mthumb -I. -IGenerated_Source/PSoC5 -Wa,-alh=$(OUT_DIR_CortexM3)/$(basename $(<F)).lst -g -D DEBUG -Wall -ffunction-sections -ffat-lto-objects -Og -std=gnu99 -fmax-errors=5

CDEPGEN_CortexM3= -MM $< -MF $(OUT_DIR_CortexM3)/$(<F).d -MT $(OUT_DIR_CortexM3)/$(@F)  $(CFLAGS_CortexM3)

LD_BASE= arm-none-eabi-gcc
LD= $(TOOLCHAIN_DIR)/$(LD_BASE)

LDFLAGS_CortexM3= -mcpu=cortex-m3 -mthumb -l m -L Generated_Source/PSoC5 -Wl,-Map,$(OUT_DIR_CortexM3)/$(DESIGN).map -T Generated_Source/PSoC5/cm3gcc.ld -Wl,--gc-sections -g -ffunction-sections -Og -ffat-lto-objects

AS_BASE= arm-none-eabi-as
AS= $(TOOLCHAIN_DIR)/$(AS_BASE)

ASFLAGS_CortexM3= -mcpu=cortex-m3 -mthumb -I. -IGenerated_Source/PSoC5 -alh=$(OUT_DIR_CortexM3)/$(basename $(<F)).lst -g -W

AR_BASE= arm-none-eabi-ar
AR= $(TOOLCHAIN_DIR)/$(AR_BASE)
ARFLAGS= -rs

RM= del
RMFLAGS= /s /q
